﻿using System.ServiceModel.Description;

namespace FC12SamlExample
{
    public class HttpAuthHeaderEndpointBehavior : IEndpointBehavior
    {
        public string AuthTicket { get; }

        public HttpAuthHeaderEndpointBehavior( string authTicket )
        {
            AuthTicket = authTicket;
        }
        
        public void AddBindingParameters( ServiceEndpoint endpoint, System.ServiceModel.Channels.BindingParameterCollection bindingParameters )
        {
            // No implementation necessary  
        }

        public void ApplyClientBehavior( ServiceEndpoint endpoint, System.ServiceModel.Dispatcher.ClientRuntime clientRuntime )
        {
            clientRuntime.MessageInspectors.Add( new HttpAuthHeaderMessageInspector( AuthTicket ) );
        }

        public void ApplyDispatchBehavior( ServiceEndpoint endpoint, System.ServiceModel.Dispatcher.EndpointDispatcher endpointDispatcher )
        {
            // No implementation necessary  
        }
        public void Validate( ServiceEndpoint endpoint )
        {
            // No implementation necessary  
        }
    }
}
